﻿Type=Service
Version=2.02
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	Dim Test As Boolean: Test = False
	Dim AlNotify As Notification
	Dim pin1act As Boolean: Dim pin1old As Boolean
	Dim pin2act As Boolean: Dim pin2old As Boolean
	Dim pin3act As Boolean: Dim pin3old As Boolean
	Dim pin4act As Boolean: Dim pin4old As Boolean
	Dim pin22act As Boolean: Dim pin22old As Boolean
	Dim tmrSvc1s As Timer: Dim Svc1s As Boolean
	Dim tmrSvcticker As Timer
	Dim tmrBeeper As Timer
	Dim currentBeeper As Int
	Dim now As Long: Dim dt As String
	Dim cntpin22 As Int: Dim cntAlive As Int
End Sub
Sub Service_Create
	DateTime.DateFormat="HHmmss"
	now=DateTime.now:dt=DateTime.Time(now)
	tmrSvcticker.Initialize("tmrSvcticker",100): tmrSvcticker.Enabled = True
	tmrSvc1s.Initialize("tmrSvc1s",1000): tmrSvc1s.Enabled = True
	AlNotify.Initialize
	AlNotify.Icon = "icon"
End Sub

Sub Service_Start (StartingIntent As Intent)
	AlNotify.Setinfo ("Notification","Foreground",Main)
	tmrBeeper.Initialize("tmrBeeper",300) 'should be >= longest beep
	currentBeeper = 0
	cntAlive = 0
	pin3act = True
	Service.StartForeground (1,AlNotify)
End Sub

Sub Service_Destroy
	Service.StopForeground(1)
End Sub

Sub tmrSvcticker_tick
	pin1old = pin1act
	pin1act = Main.pin1.Read
	If pin1act = True AND pin1old = False Then
		currentBeeper = 1: tmrBeeper.Enabled = True
		Log (dt & "   pin1 = H")
		If Test Then
		Main.Sms1.Send("0123456789",("PKG_Alarm-1 Zeit: " & dt))
		End If
	End If
	pin2old = pin2act
	pin2act = Main.pin2.Read
	If pin2act = True AND pin2old = False Then
		currentBeeper = 2: tmrBeeper.Enabled = True
		Log (dt & "   pin2 = H")
		If Test Then
		Main.Sms1.Send("0123456789",("PKG_HILFERUF Zeit: " & dt))
		End If
	End If
	pin3old = pin3act
	pin3act = Main.pin3.Read
	If pin3act = False AND pin3old = True Then
		currentBeeper = 0: tmrBeeper.Enabled = True
		Log (dt & "   pin3 = L")
		If Test Then
		Main.Sms1.Send("0123456789",("PKG_Strom-AUSFALL Zeit: " & dt))
		End If
	End If
	If pin3act = True AND pin3old = False Then
		currentBeeper = 3: tmrBeeper.Enabled = True
		Log (dt & "   pin3 = H")
		If Test Then
		Main.Sms1.Send("0123456789",("PKG_Strom-WIEDERKEHR Zeit: " & dt))
		End If
	End If
	pin4old = pin4act
	pin4act = Main.pin4.Read
	If pin4act = True AND pin4old = False Then
		currentBeeper = 0: tmrBeeper.Enabled = True
		Log (dt & "   pin4 = H")
	End If
	pin22old = pin22act
	pin22act = Main.pin22.Read
	If pin22act = True AND pin22old = False Then
		'rising edge pin22
		cntpin22 = cntpin22 + 1 'increments each change of pin22
		If cntpin22 > 600 Then
			cntAlive = cntAlive + 1
			Log (dt & " pin22 alive signal / count: " & cntAlive)
			cntpin22 = 1
		End If
	End If
	End Sub

Sub tmrSvc1s_tick
	If Svc1s = True Then
		Svc1s = False
	Else
		Svc1s = True
	End If
	Main.pin21.Write=Svc1s 'IOIO-ctrl is alive feedback out
	now=DateTime.now:dt=DateTime.Time(now)
End Sub

Sub tmrBeeper_tick
	Main.beepers(currentBeeper).Beep
	tmrBeeper.Enabled = False
End Sub


